<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cy__serial__flash__qspi_8c" kind="file" language="C++">
    <compoundname>cy_serial_flash_qspi.c</compoundname>
    <includes local="no">stdbool.h</includes>
    <includes local="yes" refid="cy__serial__flash__qspi_8h">cy_serial_flash_qspi.h</includes>
    <includes local="yes">cyhal_qspi.h</includes>
    <includes local="yes">cy_utils.h</includes>
    <incdepgraph>
      <node id="4">
        <label>stdbool.h</label>
      </node>
      <node id="3">
        <label>cy_serial_flash_qspi.c</label>
        <link refid="cy__serial__flash__qspi_8c" />
        <childnode refid="4" relation="include">
        </childnode>
        <childnode refid="5" relation="include">
        </childnode>
        <childnode refid="6" relation="include">
        </childnode>
      </node>
      <node id="5">
        <label>cyhal_qspi.h</label>
      </node>
      <node id="6">
        <label>cy_utils.h</label>
      </node>
    </incdepgraph>
      <sectiondef kind="var">
      <memberdef id="cy__serial__flash__qspi_8c_1ad5e72e00bf13a8d7eeac9d36483283e3" kind="variable" mutable="no" prot="public" static="yes">
        <type>cyhal_qspi_t</type>
        <definition>cyhal_qspi_t qspi_obj</definition>
        <argsstring />
        <name>qspi_obj</name>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" bodystart="55" column="1" file="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" line="55" />
      </memberdef>
      <memberdef id="cy__serial__flash__qspi_8c_1ae2ac82d9f355a01ae5883809d4fe8ad4" kind="variable" mutable="no" prot="public" static="yes">
        <type>cy_stc_smif_mem_config_t *</type>
        <definition>cy_stc_smif_mem_config_t* qspi_mem_config[SMIF_MEM_DEVICES]</definition>
        <argsstring>[SMIF_MEM_DEVICES]</argsstring>
        <name>qspi_mem_config</name>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" bodystart="57" column="1" file="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" line="57" />
      </memberdef>
      <memberdef id="cy__serial__flash__qspi_8c_1a38d362fe9dadd024720c1f72d71bd08e" kind="variable" mutable="no" prot="public" static="yes">
        <type>cy_stc_smif_block_config_t</type>
        <definition>cy_stc_smif_block_config_t qspi_block_config</definition>
        <argsstring />
        <name>qspi_block_config</name>
        <initializer>=
{
    
    .memCount = SMIF_MEM_DEVICES,
    
    .memConfig = (cy_stc_smif_mem_config_t**)qspi_mem_config,
    
    .majorVersion = CY_SMIF_DRV_VERSION_MAJOR,
    
    .minorVersion = CY_SMIF_DRV_VERSION_MINOR
}</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" bodystart="59" column="1" file="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" line="59" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__board__libs_1gaa9c587684b8b629a0fde56e786400d82" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_serial_flash_qspi_init</definition>
        <argsstring>(const cy_stc_smif_mem_config_t *mem_config, cyhal_gpio_t io0, cyhal_gpio_t io1, cyhal_gpio_t io2, cyhal_gpio_t io3, cyhal_gpio_t io4, cyhal_gpio_t io5, cyhal_gpio_t io6, cyhal_gpio_t io7, cyhal_gpio_t sclk, cyhal_gpio_t ssel, uint32_t hz)</argsstring>
        <name>cy_serial_flash_qspi_init</name>
        <param>
          <type>const cy_stc_smif_mem_config_t *</type>
          <declname>mem_config</declname>
        </param>
        <param>
          <type>cyhal_gpio_t</type>
          <declname>io0</declname>
        </param>
        <param>
          <type>cyhal_gpio_t</type>
          <declname>io1</declname>
        </param>
        <param>
          <type>cyhal_gpio_t</type>
          <declname>io2</declname>
        </param>
        <param>
          <type>cyhal_gpio_t</type>
          <declname>io3</declname>
        </param>
        <param>
          <type>cyhal_gpio_t</type>
          <declname>io4</declname>
        </param>
        <param>
          <type>cyhal_gpio_t</type>
          <declname>io5</declname>
        </param>
        <param>
          <type>cyhal_gpio_t</type>
          <declname>io6</declname>
        </param>
        <param>
          <type>cyhal_gpio_t</type>
          <declname>io7</declname>
        </param>
        <param>
          <type>cyhal_gpio_t</type>
          <declname>sclk</declname>
        </param>
        <param>
          <type>cyhal_gpio_t</type>
          <declname>ssel</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>hz</declname>
        </param>
        <briefdescription>
<para>Initializes the serial flash memory. </para>        </briefdescription>
        <detaileddescription>
<para>This function accepts up to 8 I/Os. Number of I/Os depend on the type of memory interface. Pass NC when an I/O is unused. Single SPI - (io0, io1) or (io2, io3) or (io4, io5) or (io6, io7) Dual SPI - (io0, io1) or (io2, io3) or (io4, io5) or (io6, io7) Quad SPI - (io0, io1, io2, io3) or (io4, io5, io6, io7) Octal SPI - All 8 I/Os are used. <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>mem_config</parametername>
</parameternamelist>
<parameterdescription>
<para>Memory configuration to be used for initializing </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>io0</parametername>
</parameternamelist>
<parameterdescription>
<para>Data/IO pin 0 connected to the memory, Pass NC when unused. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>io1</parametername>
</parameternamelist>
<parameterdescription>
<para>Data/IO pin 1 connected to the memory, Pass NC when unused. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>io2</parametername>
</parameternamelist>
<parameterdescription>
<para>Data/IO pin 2 connected to the memory, Pass NC when unused. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>io3</parametername>
</parameternamelist>
<parameterdescription>
<para>Data/IO pin 3 connected to the memory, Pass NC when unused. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>io4</parametername>
</parameternamelist>
<parameterdescription>
<para>Data/IO pin 4 connected to the memory, Pass NC when unused. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>io5</parametername>
</parameternamelist>
<parameterdescription>
<para>Data/IO pin 5 connected to the memory, Pass NC when unused. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>io6</parametername>
</parameternamelist>
<parameterdescription>
<para>Data/IO pin 6 connected to the memory, Pass NC when unused. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>io7</parametername>
</parameternamelist>
<parameterdescription>
<para>Data/IO pin 7 connected to the memory, Pass NC when unused. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>sclk</parametername>
</parameternamelist>
<parameterdescription>
<para>Clock pin connected to the memory </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>ssel</parametername>
</parameternamelist>
<parameterdescription>
<para>Slave select pin connected to the memory </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>hz</parametername>
</parameternamelist>
<parameterdescription>
<para>Clock frequency to be used with the memory. This parameter is ignored currently. Change the CLK_HF frequency using either the Device Configurator tool or the clock driver. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS if the initialization was successful, an error code otherwise. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="137" bodyfile="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" bodystart="76" column="1" file="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" line="76" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__board__libs_1gac4914a8bff25287d43c661d6cd68fbfd" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cy_serial_flash_qspi_deinit</definition>
        <argsstring>(void)</argsstring>
        <name>cy_serial_flash_qspi_deinit</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>De-initializes the serial flash memory. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="147" bodyfile="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" bodystart="139" column="1" file="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" line="139" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__board__libs_1ga7b9bff94b0c4ba30b11de9f64a0e4980" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>size_t</type>
        <definition>size_t cy_serial_flash_qspi_get_size</definition>
        <argsstring>(void)</argsstring>
        <name>cy_serial_flash_qspi_get_size</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Returns the size of the serial flash memory in bytes. </para>        </briefdescription>
        <detaileddescription>
<para><simplesect kind="return"><para>Memory size in bytes. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="152" bodyfile="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" bodystart="149" column="1" file="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" line="149" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__board__libs_1gacaad29bc13d3a4cd243830980b21c274" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>size_t</type>
        <definition>size_t cy_serial_flash_qspi_get_erase_size</definition>
        <argsstring>(uint32_t addr)</argsstring>
        <name>cy_serial_flash_qspi_get_erase_size</name>
        <param>
          <type>uint32_t</type>
          <declname>addr</declname>
        </param>
        <briefdescription>
<para>Returns the size of the erase sector to which the given address belongs. </para>        </briefdescription>
        <detaileddescription>
<para>Address is used only for a memory with hybrid sector size. <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>addr</parametername>
</parameternamelist>
<parameterdescription>
<para>Address that belongs to the sector for which size is returned. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Erase sector size in bytes. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="161" bodyfile="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" bodystart="157" column="1" file="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" line="157" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__board__libs_1ga8b700333be27d3f22dbf2b7a273e7f1e" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_serial_flash_qspi_read</definition>
        <argsstring>(uint32_t addr, size_t length, uint8_t *buf)</argsstring>
        <name>cy_serial_flash_qspi_read</name>
        <param>
          <type>uint32_t</type>
          <declname>addr</declname>
        </param>
        <param>
          <type>size_t</type>
          <declname>length</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>buf</declname>
        </param>
        <briefdescription>
<para>Reads data from the serial flash memory. </para>        </briefdescription>
        <detaileddescription>
<para>This is a blocking function. Returns error if (addr + length) exceeds the flash size. <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>addr</parametername>
</parameternamelist>
<parameterdescription>
<para>Starting address to read from </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>length</parametername>
</parameternamelist>
<parameterdescription>
<para>Number of data bytes to read </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>buf</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to the buffer to store the data read from the memory </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS if the read was successful, an error code otherwise. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="167" bodyfile="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" bodystart="163" column="1" file="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" line="163" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__board__libs_1gab7e5444e256507f0bc5d112d6741621a" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_serial_flash_qspi_write</definition>
        <argsstring>(uint32_t addr, size_t length, const uint8_t *buf)</argsstring>
        <name>cy_serial_flash_qspi_write</name>
        <param>
          <type>uint32_t</type>
          <declname>addr</declname>
        </param>
        <param>
          <type>size_t</type>
          <declname>length</declname>
        </param>
        <param>
          <type>const uint8_t *</type>
          <declname>buf</declname>
        </param>
        <briefdescription>
<para>Writes the data to the serial flash memory. </para>        </briefdescription>
        <detaileddescription>
<para>The program area must have been erased prior to calling this API using <ref kindref="member" refid="group__group__board__libs_1ga41c8380588bc01b6a8320b23bc172649">cy_serial_flash_qspi_erase()</ref> This is a blocking function. Returns error if (addr + length) exceeds the flash size. <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>addr</parametername>
</parameternamelist>
<parameterdescription>
<para>Starting address to write to </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>length</parametername>
</parameternamelist>
<parameterdescription>
<para>Number of bytes to write </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>buf</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to the buffer storing the data to be written </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS if the write was successful, an error code otherwise. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="173" bodyfile="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" bodystart="169" column="1" file="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" line="169" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__board__libs_1ga41c8380588bc01b6a8320b23bc172649" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_serial_flash_qspi_erase</definition>
        <argsstring>(uint32_t addr, size_t length)</argsstring>
        <name>cy_serial_flash_qspi_erase</name>
        <param>
          <type>uint32_t</type>
          <declname>addr</declname>
        </param>
        <param>
          <type>size_t</type>
          <declname>length</declname>
        </param>
        <briefdescription>
<para>Erases the serial flash memory, uses chip erase command when addr = 0 and length = flash_size otherwise uses sector erase command. </para>        </briefdescription>
        <detaileddescription>
<para>This is a blocking function. Returns error if addr or (addr + length) is not aligned to the sector size or if (addr + length) exceeds the flash size. Call <ref kindref="member" refid="group__group__board__libs_1ga7b9bff94b0c4ba30b11de9f64a0e4980">cy_serial_flash_qspi_get_size()</ref> to get the flash size and call <ref kindref="member" refid="group__group__board__libs_1gacaad29bc13d3a4cd243830980b21c274">cy_serial_flash_qspi_get_erase_size()</ref> to get the size of an erase sector.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>addr</parametername>
</parameternamelist>
<parameterdescription>
<para>Starting address to begin erasing </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>length</parametername>
</parameternamelist>
<parameterdescription>
<para>Number of bytes to erase </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS if the erase was successful, an error code otherwise. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="198" bodyfile="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" bodystart="179" column="1" file="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" line="179" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__board__libs_1ga56772d2543b7b7f2c17ed9ddb9db941e" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_serial_flash_qspi_enable_xip</definition>
        <argsstring>(bool enable)</argsstring>
        <name>cy_serial_flash_qspi_enable_xip</name>
        <param>
          <type>bool</type>
          <declname>enable</declname>
        </param>
        <briefdescription>
<para>Enables Execute-in-Place (memory mapped) mode on the MCU. </para>        </briefdescription>
        <detaileddescription>
<para>This function does not send any command to the serial flash. This may not be supported on all the targets in which case CY_RSLT_SERIAL_FLASH_ERR_UNSUPPORTED is returned. <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>enable</parametername>
</parameternamelist>
<parameterdescription>
<para>true: XIP mode is set, false: normal mode is set </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS if the operation was successful. CY_RSLT_SERIAL_FLASH_ERR_UNSUPPORTED if the target does not support XIP. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="216" bodyfile="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" bodystart="204" column="1" file="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" line="204" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>Provides APIs for interacting with an external flash connected to the SPI or QSPI interface, uses SFDP to auto-discover memory properties if SFDP is enabled in the configuration. </para>    </briefdescription>
    <detaileddescription>
<para><simplesect kind="copyright"><para>Copyright 2018-2020 Cypress Semiconductor Corporation SPDX-License-Identifier: Apache-2.0</para></simplesect>
Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at <verbatim>http://www.apache.org/licenses/LICENSE-2.0
</verbatim></para><para>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/***************************************************************************/</highlight></codeline>
<codeline lineno="27"><highlight class="preprocessor">#include<sp />&lt;stdbool.h&gt;</highlight><highlight class="normal" /></codeline>
<codeline lineno="28"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_serial_flash_qspi.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="29"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_qspi.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="30"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_utils.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="31"><highlight class="normal" /></codeline>
<codeline lineno="32"><highlight class="normal" /><highlight class="preprocessor">#ifdef<sp />CY_IP_MXSMIF</highlight><highlight class="normal" /></codeline>
<codeline lineno="33"><highlight class="normal" /></codeline>
<codeline lineno="34"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="35"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="36"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="37"><highlight class="normal" /></codeline>
<codeline lineno="38"><highlight class="normal" /></codeline>
<codeline lineno="44"><highlight class="preprocessor">#define<sp />CY_SERIAL_FLASH_QUAD_ENABLE_TIMEOUT_US<sp /><sp /><sp /><sp /><sp /><sp />(5000lu)<sp /></highlight><highlight class="comment">/*<sp />in<sp />microseconds<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="45"><highlight class="normal" /></codeline>
<codeline lineno="46"><highlight class="normal" /><highlight class="comment">/*<sp />Number<sp />of<sp />memories<sp />supported<sp />by<sp />the<sp />driver<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="47"><highlight class="normal" /><highlight class="preprocessor">#define<sp />SMIF_MEM_DEVICES<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(1u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="48"><highlight class="normal" /></codeline>
<codeline lineno="49"><highlight class="normal" /><highlight class="comment">/*<sp />SMIF<sp />slot<sp />from<sp />which<sp />the<sp />memory<sp />configuration<sp />is<sp />picked<sp />up<sp />-<sp />fixed<sp />to<sp />0<sp />as<sp />the<sp />driver</highlight></codeline>
<codeline lineno="50"><highlight class="comment"><sp />*<sp />supports<sp />only<sp />one<sp />device<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="51"><highlight class="normal" /><highlight class="preprocessor">#define<sp />MEM_SLOT<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(0u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="52"><highlight class="normal" /></codeline>
<codeline lineno="55"><highlight class="keyword">static</highlight><highlight class="normal"><sp />cyhal_qspi_t<sp />qspi_obj;</highlight></codeline>
<codeline lineno="56"><highlight class="normal" /></codeline>
<codeline lineno="57"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />cy_stc_smif_mem_config_t<sp />*<sp />qspi_mem_config[SMIF_MEM_DEVICES];</highlight></codeline>
<codeline lineno="58"><highlight class="normal" /></codeline>
<codeline lineno="59"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />cy_stc_smif_block_config_t<sp />qspi_block_config<sp />=</highlight></codeline>
<codeline lineno="60"><highlight class="normal">{</highlight></codeline>
<codeline lineno="61"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />number<sp />of<sp />SMIF<sp />memories<sp />defined.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="62"><highlight class="normal"><sp /><sp /><sp /><sp />.memCount<sp />=<sp />SMIF_MEM_DEVICES,</highlight></codeline>
<codeline lineno="63"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />pointer<sp />to<sp />the<sp />array<sp />of<sp />memory<sp />config<sp />structures<sp />of<sp />size<sp />memCount.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="64"><highlight class="normal"><sp /><sp /><sp /><sp />.memConfig<sp />=<sp />(cy_stc_smif_mem_config_t**)qspi_mem_config,</highlight></codeline>
<codeline lineno="65"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />version<sp />of<sp />the<sp />SMIF<sp />driver.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="66"><highlight class="normal"><sp /><sp /><sp /><sp />.majorVersion<sp />=<sp />CY_SMIF_DRV_VERSION_MAJOR,</highlight></codeline>
<codeline lineno="67"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />version<sp />of<sp />the<sp />SMIF<sp />driver.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="68"><highlight class="normal"><sp /><sp /><sp /><sp />.minorVersion<sp />=<sp />CY_SMIF_DRV_VERSION_MINOR</highlight></codeline>
<codeline lineno="69"><highlight class="normal">};</highlight></codeline>
<codeline lineno="70"><highlight class="normal" /></codeline>
<codeline lineno="71"><highlight class="normal" /><highlight class="comment">/*<sp />The<sp />driver<sp />supports<sp />only<sp />one<sp />memory.<sp />When<sp />multiple<sp />memory<sp />configurations</highlight></codeline>
<codeline lineno="72"><highlight class="comment"><sp />*<sp />are<sp />generated<sp />by<sp />the<sp />SMIF<sp />configurator<sp />tool,<sp />provide<sp />only<sp />the</highlight></codeline>
<codeline lineno="73"><highlight class="comment"><sp />*<sp />configuration<sp />for<sp />memory<sp />that<sp />need<sp />to<sp />be<sp />supported<sp />by<sp />the<sp />driver.</highlight></codeline>
<codeline lineno="74"><highlight class="comment"><sp />*<sp />Memory<sp />configuration<sp />can<sp />be<sp />changed<sp />by<sp />deinit<sp />followed<sp />by<sp />init<sp />with<sp />new</highlight></codeline>
<codeline lineno="75"><highlight class="comment"><sp />*<sp />configuration<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="76"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__board__libs_1gaa9c587684b8b629a0fde56e786400d82">cy_serial_flash_qspi_init</ref>(</highlight></codeline>
<codeline lineno="77"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />cy_stc_smif_mem_config_t*<sp />mem_config,</highlight></codeline>
<codeline lineno="78"><highlight class="normal"><sp /><sp /><sp /><sp />cyhal_gpio_t<sp />io0,</highlight></codeline>
<codeline lineno="79"><highlight class="normal"><sp /><sp /><sp /><sp />cyhal_gpio_t<sp />io1,</highlight></codeline>
<codeline lineno="80"><highlight class="normal"><sp /><sp /><sp /><sp />cyhal_gpio_t<sp />io2,</highlight></codeline>
<codeline lineno="81"><highlight class="normal"><sp /><sp /><sp /><sp />cyhal_gpio_t<sp />io3,</highlight></codeline>
<codeline lineno="82"><highlight class="normal"><sp /><sp /><sp /><sp />cyhal_gpio_t<sp />io4,</highlight></codeline>
<codeline lineno="83"><highlight class="normal"><sp /><sp /><sp /><sp />cyhal_gpio_t<sp />io5,</highlight></codeline>
<codeline lineno="84"><highlight class="normal"><sp /><sp /><sp /><sp />cyhal_gpio_t<sp />io6,</highlight></codeline>
<codeline lineno="85"><highlight class="normal"><sp /><sp /><sp /><sp />cyhal_gpio_t<sp />io7,</highlight></codeline>
<codeline lineno="86"><highlight class="normal"><sp /><sp /><sp /><sp />cyhal_gpio_t<sp />sclk,</highlight></codeline>
<codeline lineno="87"><highlight class="normal"><sp /><sp /><sp /><sp />cyhal_gpio_t<sp />ssel,</highlight></codeline>
<codeline lineno="88"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />hz)</highlight></codeline>
<codeline lineno="89"><highlight class="normal">{</highlight></codeline>
<codeline lineno="90"><highlight class="normal"><sp /><sp /><sp /><sp />cy_en_smif_status_t<sp />smifStatus<sp />=<sp />CY_SMIF_SUCCESS;</highlight></codeline>
<codeline lineno="91"><highlight class="normal" /></codeline>
<codeline lineno="92"><highlight class="normal" /></codeline>
<codeline lineno="93"><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />result<sp />=<sp />cyhal_qspi_init(&amp;qspi_obj,<sp />io0,<sp />io1,<sp />io2,<sp />io3,<sp />io4,<sp />io5,<sp />io6,<sp />io7,</highlight></codeline>
<codeline lineno="94"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />sclk,<sp />ssel,<sp />hz,<sp />0);</highlight></codeline>
<codeline lineno="95"><highlight class="normal" /></codeline>
<codeline lineno="96"><highlight class="normal"><sp /><sp /><sp /><sp />qspi_mem_config[MEM_SLOT]<sp />=<sp />(cy_stc_smif_mem_config_t*)<sp />mem_config;</highlight></codeline>
<codeline lineno="97"><highlight class="normal" /></codeline>
<codeline lineno="98"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(CY_RSLT_SUCCESS<sp />==<sp />result)</highlight></codeline>
<codeline lineno="99"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="100"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Perform<sp />SFDP<sp />detection<sp />and<sp />XIP<sp />register<sp />configuration<sp />depending<sp />on<sp />the</highlight></codeline>
<codeline lineno="101"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />memory<sp />configuration.</highlight></codeline>
<codeline lineno="102"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="103"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />smifStatus<sp />=<sp />Cy_SMIF_MemInit(qspi_obj.base,<sp />&amp;qspi_block_config,<sp />&amp;qspi_obj.context);</highlight></codeline>
<codeline lineno="104"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(CY_SMIF_SUCCESS<sp />==<sp />smifStatus)</highlight></codeline>
<codeline lineno="105"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="106"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />Quad<sp />mode<sp />(1-1-4<sp />or<sp />1-4-4<sp />modes)<sp />to<sp />use<sp />all<sp />the<sp />four<sp />I/Os<sp />during</highlight></codeline>
<codeline lineno="107"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />communication.</highlight></codeline>
<codeline lineno="108"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="109"><highlight class="normal" /></codeline>
<codeline lineno="110"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(qspi_block_config.memConfig[MEM_SLOT]-&gt;deviceCfg-&gt;readCmd-&gt;dataWidth<sp />==<sp />CY_SMIF_WIDTH_QUAD</highlight></codeline>
<codeline lineno="111"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />||<sp />qspi_block_config.memConfig[MEM_SLOT]-&gt;deviceCfg-&gt;programCmd-&gt;dataWidth<sp />==<sp />CY_SMIF_WIDTH_QUAD)</highlight></codeline>
<codeline lineno="112"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="113"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />isQuadEnabled<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">;</highlight></codeline>
<codeline lineno="114"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />smifStatus<sp />=<sp />Cy_SMIF_MemIsQuadEnabled(qspi_obj.base,<sp />qspi_block_config.memConfig[MEM_SLOT],<sp />&amp;isQuadEnabled,<sp />&amp;qspi_obj.context);</highlight></codeline>
<codeline lineno="115"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(CY_SMIF_SUCCESS<sp />==<sp />smifStatus)</highlight></codeline>
<codeline lineno="116"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="117"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(!isQuadEnabled)</highlight></codeline>
<codeline lineno="118"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="119"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />smifStatus<sp />=<sp />Cy_SMIF_MemEnableQuadMode(qspi_obj.base,<sp />qspi_block_config.memConfig[MEM_SLOT],<sp />CY_SERIAL_FLASH_QUAD_ENABLE_TIMEOUT_US,<sp />&amp;qspi_obj.context);</highlight></codeline>
<codeline lineno="120"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="121"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="122"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="123"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="124"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="125"><highlight class="normal" /></codeline>
<codeline lineno="126"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">((CY_RSLT_SUCCESS<sp />!=<sp />result)<sp />||<sp />(CY_SMIF_SUCCESS<sp />!=<sp />smifStatus))</highlight></codeline>
<codeline lineno="127"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="128"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__board__libs_1gac4914a8bff25287d43c661d6cd68fbfd">cy_serial_flash_qspi_deinit</ref>();</highlight></codeline>
<codeline lineno="129"><highlight class="normal" /></codeline>
<codeline lineno="130"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(CY_SMIF_SUCCESS<sp />!=<sp />smifStatus)</highlight></codeline>
<codeline lineno="131"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="132"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />(cy_rslt_t)smifStatus;</highlight></codeline>
<codeline lineno="133"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="134"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="135"><highlight class="normal" /></codeline>
<codeline lineno="136"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />result;</highlight></codeline>
<codeline lineno="137"><highlight class="normal">}</highlight></codeline>
<codeline lineno="138"><highlight class="normal" /></codeline>
<codeline lineno="139"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__board__libs_1gac4914a8bff25287d43c661d6cd68fbfd">cy_serial_flash_qspi_deinit</ref>(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="140"><highlight class="normal">{</highlight></codeline>
<codeline lineno="141"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(qspi_obj.base<sp />!=<sp />NULL)</highlight></codeline>
<codeline lineno="142"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="143"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_SMIF_MemDeInit(qspi_obj.base);</highlight></codeline>
<codeline lineno="144"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="145"><highlight class="normal" /></codeline>
<codeline lineno="146"><highlight class="normal"><sp /><sp /><sp /><sp />cyhal_qspi_free(&amp;qspi_obj);</highlight></codeline>
<codeline lineno="147"><highlight class="normal">}</highlight></codeline>
<codeline lineno="148"><highlight class="normal" /></codeline>
<codeline lineno="149"><highlight class="normal" /><highlight class="keywordtype">size_t</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__board__libs_1ga7b9bff94b0c4ba30b11de9f64a0e4980">cy_serial_flash_qspi_get_size</ref>(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="150"><highlight class="normal">{</highlight></codeline>
<codeline lineno="151"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(</highlight><highlight class="keywordtype">size_t</highlight><highlight class="normal">)qspi_block_config.memConfig[MEM_SLOT]-&gt;deviceCfg-&gt;memSize;</highlight></codeline>
<codeline lineno="152"><highlight class="normal">}</highlight></codeline>
<codeline lineno="153"><highlight class="normal" /></codeline>
<codeline lineno="154"><highlight class="normal" /><highlight class="comment">/*<sp />address<sp />is<sp />ignored<sp />for<sp />the<sp />memory<sp />with<sp />uniform<sp />sector<sp />size.<sp />Currently,</highlight></codeline>
<codeline lineno="155"><highlight class="comment"><sp />*<sp />QSPI<sp />Configurator<sp />does<sp />not<sp />support<sp />memories<sp />with<sp />hybrid<sp />sectors.</highlight></codeline>
<codeline lineno="156"><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="157"><highlight class="normal" /><highlight class="keywordtype">size_t</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__board__libs_1gacaad29bc13d3a4cd243830980b21c274">cy_serial_flash_qspi_get_erase_size</ref>(uint32_t<sp />addr)</highlight></codeline>
<codeline lineno="158"><highlight class="normal">{</highlight></codeline>
<codeline lineno="159"><highlight class="normal"><sp /><sp /><sp /><sp />CY_UNUSED_PARAMETER(addr);</highlight></codeline>
<codeline lineno="160"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(</highlight><highlight class="keywordtype">size_t</highlight><highlight class="normal">)qspi_block_config.memConfig[MEM_SLOT]-&gt;deviceCfg-&gt;eraseSize;</highlight></codeline>
<codeline lineno="161"><highlight class="normal">}</highlight></codeline>
<codeline lineno="162"><highlight class="normal" /></codeline>
<codeline lineno="163"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__board__libs_1ga8b700333be27d3f22dbf2b7a273e7f1e">cy_serial_flash_qspi_read</ref>(uint32_t<sp />addr,<sp /></highlight><highlight class="keywordtype">size_t</highlight><highlight class="normal"><sp />length,<sp />uint8_t<sp />*buf)</highlight></codeline>
<codeline lineno="164"><highlight class="normal">{</highlight></codeline>
<codeline lineno="165"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Cy_SMIF_MemRead()<sp />returns<sp />error<sp />if<sp />(addr<sp />+<sp />length)<sp />&gt;<sp />total<sp />flash<sp />size.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="166"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(cy_rslt_t)Cy_SMIF_MemRead(qspi_obj.base,<sp />qspi_block_config.memConfig[MEM_SLOT],<sp />addr,<sp />buf,<sp />length,<sp />&amp;qspi_obj.context);</highlight></codeline>
<codeline lineno="167"><highlight class="normal">}</highlight></codeline>
<codeline lineno="168"><highlight class="normal" /></codeline>
<codeline lineno="169"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__board__libs_1gab7e5444e256507f0bc5d112d6741621a">cy_serial_flash_qspi_write</ref>(uint32_t<sp />addr,<sp /></highlight><highlight class="keywordtype">size_t</highlight><highlight class="normal"><sp />length,<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint8_t<sp />*buf)</highlight></codeline>
<codeline lineno="170"><highlight class="normal">{</highlight></codeline>
<codeline lineno="171"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Cy_SMIF_MemWrite()<sp />returns<sp />error<sp />if<sp />(addr<sp />+<sp />length)<sp />&gt;<sp />total<sp />flash<sp />size.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="172"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(cy_rslt_t)Cy_SMIF_MemWrite(qspi_obj.base,<sp />qspi_block_config.memConfig[MEM_SLOT],<sp />addr,<sp />(uint8_t<sp />*)buf,<sp />length,<sp />&amp;qspi_obj.context);</highlight></codeline>
<codeline lineno="173"><highlight class="normal">}</highlight></codeline>
<codeline lineno="174"><highlight class="normal" /></codeline>
<codeline lineno="175"><highlight class="normal" /><highlight class="comment">/*<sp />Does<sp />not<sp />support<sp />hybrid<sp />sectors,<sp />sector<sp />size<sp />must<sp />be<sp />uniform<sp />on<sp />the<sp />entire</highlight></codeline>
<codeline lineno="176"><highlight class="comment"><sp />*<sp />chip.<sp />Use<sp />cy_serial_flash_qspi_get_erase_size(addr)<sp />to<sp />implement<sp />hybrid<sp />sector</highlight></codeline>
<codeline lineno="177"><highlight class="comment"><sp />*<sp />support<sp />when<sp />QSPI<sp />Configurator<sp />and<sp />PDL<sp />supports<sp />memories<sp />with<sp />hybrid<sp />sectors.</highlight></codeline>
<codeline lineno="178"><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="179"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__board__libs_1ga41c8380588bc01b6a8320b23bc172649">cy_serial_flash_qspi_erase</ref>(uint32_t<sp />addr,<sp /></highlight><highlight class="keywordtype">size_t</highlight><highlight class="normal"><sp />length)</highlight></codeline>
<codeline lineno="180"><highlight class="normal">{</highlight></codeline>
<codeline lineno="181"><highlight class="normal"><sp /><sp /><sp /><sp />cy_en_smif_status_t<sp />smifStatus;</highlight></codeline>
<codeline lineno="182"><highlight class="normal" /></codeline>
<codeline lineno="183"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />If<sp />the<sp />erase<sp />is<sp />for<sp />the<sp />entire<sp />chip,<sp />use<sp />chip<sp />erase<sp />command<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="184"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">((addr<sp />==<sp />0u)<sp />&amp;&amp;<sp />(length<sp />==<sp /><ref kindref="member" refid="group__group__board__libs_1ga7b9bff94b0c4ba30b11de9f64a0e4980">cy_serial_flash_qspi_get_size</ref>()))</highlight></codeline>
<codeline lineno="185"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="186"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />smifStatus<sp />=<sp />Cy_SMIF_MemEraseChip(qspi_obj.base,<sp />qspi_block_config.memConfig[MEM_SLOT],<sp />&amp;qspi_obj.context);</highlight></codeline>
<codeline lineno="187"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="188"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="189"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="190"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Cy_SMIF_MemEraseSector()<sp />returns<sp />error<sp />if<sp />(addr<sp />+<sp />length)<sp />&gt;<sp />total<sp />flash<sp />size</highlight></codeline>
<codeline lineno="191"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />or<sp />if<sp />addr<sp />is<sp />not<sp />aligned<sp />to<sp />erase<sp />sector<sp />size<sp />or<sp />if<sp />(addr<sp />+<sp />length)</highlight></codeline>
<codeline lineno="192"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />is<sp />not<sp />aligned<sp />to<sp />erase<sp />sector<sp />size.</highlight></codeline>
<codeline lineno="193"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="194"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />smifStatus<sp />=<sp />Cy_SMIF_MemEraseSector(qspi_obj.base,<sp />qspi_block_config.memConfig[MEM_SLOT],<sp />addr,<sp />length,<sp />&amp;qspi_obj.context);</highlight></codeline>
<codeline lineno="195"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="196"><highlight class="normal" /></codeline>
<codeline lineno="197"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(cy_rslt_t)smifStatus;</highlight></codeline>
<codeline lineno="198"><highlight class="normal">}</highlight></codeline>
<codeline lineno="199"><highlight class="normal" /></codeline>
<codeline lineno="200"><highlight class="normal" /><highlight class="comment">//<sp />This<sp />function<sp />enables<sp />or<sp />disables<sp />XIP<sp />on<sp />the<sp />MCU,<sp />does<sp />not<sp />send<sp />any<sp />command</highlight><highlight class="normal" /></codeline>
<codeline lineno="201"><highlight class="normal" /><highlight class="comment">//<sp />to<sp />the<sp />serial<sp />flash.<sp />XIP<sp />register<sp />configuration<sp />is<sp />already<sp />done<sp />as<sp />part<sp />of</highlight><highlight class="normal" /></codeline>
<codeline lineno="202"><highlight class="normal" /><highlight class="comment">//<sp />cy_serial_flash_qspi_init()<sp />if<sp />MMIO<sp />mode<sp />is<sp />enabled<sp />in<sp />the<sp />QSPI</highlight><highlight class="normal" /></codeline>
<codeline lineno="203"><highlight class="normal" /><highlight class="comment">//<sp />Configurator.</highlight><highlight class="normal" /></codeline>
<codeline lineno="204"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__board__libs_1ga56772d2543b7b7f2c17ed9ddb9db941e">cy_serial_flash_qspi_enable_xip</ref>(</highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />enable)</highlight></codeline>
<codeline lineno="205"><highlight class="normal">{</highlight></codeline>
<codeline lineno="206"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(enable)</highlight></codeline>
<codeline lineno="207"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="208"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_SMIF_SetMode(qspi_obj.base,<sp />CY_SMIF_MEMORY);</highlight></codeline>
<codeline lineno="209"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="210"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="211"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="212"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_SMIF_SetMode(qspi_obj.base,<sp />CY_SMIF_NORMAL);</highlight></codeline>
<codeline lineno="213"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="214"><highlight class="normal" /></codeline>
<codeline lineno="215"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />CY_RSLT_SUCCESS;</highlight></codeline>
<codeline lineno="216"><highlight class="normal">}</highlight></codeline>
<codeline lineno="217"><highlight class="normal" /></codeline>
<codeline lineno="218"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="219"><highlight class="normal">}</highlight></codeline>
<codeline lineno="220"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="221"><highlight class="normal" /></codeline>
<codeline lineno="222"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CY_IP_MXSMIF<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="223"><highlight class="normal" /></codeline>
    </programlisting>
    <location file="output/libs/COMPONENT_SERIAL_FLASH/serial-flash/cy_serial_flash_qspi.c" />
  </compounddef>
</doxygen>